package com.example.wholeestate.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.example.wholeestate.common.base.BaseController;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.model.Comment;
import com.example.wholeestate.service.ICommentService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 * 评论表 前端控制器
 * </p>
 *
 * @author weiximei
 * @since 2019-03-20
 */
@RestController
@RequestMapping("/")
@Api(value = "评论 API", description = "评论 API")
public class CommentController extends BaseController {

    @Autowired
    private ICommentService iCommentService;

    @RequestMapping(value = "/comment/delete/{commentId}", method = RequestMethod.DELETE)
    @ApiOperation(value = "删除评论", notes = "删除评论")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", dataTypeClass = String.class, name = "commentId",value = "评论编号")
    })
    public ResponseBean delete(@PathVariable("commentId") String commentId) {
        ResponseBean responseBean = new ResponseBean();
        QueryWrapper<Comment> commentQueryWrapper = new QueryWrapper<>();
        commentQueryWrapper.eq("comment_id", commentId);
        Comment comment = iCommentService.getOne(commentQueryWrapper);
        if (null == comment) {
            responseBean.addError("评论不存在!");
            return responseBean;
        }

        comment.setStatus(-1);
        iCommentService.update(comment,commentQueryWrapper);

        // 删除这个评论下的子评论
        Comment  childComment = new Comment();
        childComment.setStatus(-1);
        QueryWrapper<Comment> childCommentQueryWrapper = new QueryWrapper<>();
        childCommentQueryWrapper.eq("parent_id", commentId);
        iCommentService.update(childComment, childCommentQueryWrapper);
        responseBean.addSuccess("操作成功!");
        return responseBean;
    }



}
