package com.example.wholeestate.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.dao.ActivityEnrollMapper;
import com.example.wholeestate.dao.ActivityMapper;
import com.example.wholeestate.model.Activity;
import com.example.wholeestate.model.ActivityEnroll;
import com.example.wholeestate.service.IActivityEnrollService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 活动报名表 服务实现类
 * </p>
 *
 * @author weiximei
 * @since 2019-03-20
 */
@Service
public class ActivityEnrollServiceImpl extends ServiceImpl<ActivityEnrollMapper, ActivityEnroll> implements IActivityEnrollService {

    @Autowired
    private ActivityEnrollMapper activityEnrollMapper;

    @Autowired
    private ActivityMapper activityMapper;

    @Override
    public ResponseBean getActivitySignUpList(String activityId,String parameter) {
        ResponseBean responseBean = new ResponseBean();

        Activity activity = activityMapper.selectById(activityId);
        if (null == activity) {
            responseBean.addError("活动不存在!");
            return responseBean;
        }

        JSONObject jsonObject = JSONObject.parseObject(parameter);
        Integer pageNum = jsonObject.getInteger("pageNum");
        Integer pageSize = jsonObject.getInteger("pageSize");

        Page<Activity> page = new Page<>();
        page.setCurrent(pageNum == null ? 1 : pageNum);
        page.setSize(pageSize == null ? 10 : pageSize);
        IPage<ActivityEnroll> activityEnrollIPage = activityEnrollMapper.selectPageActivityEnroll(page, activityId);

        responseBean.addSuccess(activityEnrollIPage);
        return responseBean;
    }
}
