package com.example.wholeestate.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.dao.CommentMapper;
import com.example.wholeestate.dao.CustomerMapper;
import com.example.wholeestate.model.Activity;
import com.example.wholeestate.model.Comment;
import com.example.wholeestate.model.Customer;
import com.example.wholeestate.model.SysUser;
import com.example.wholeestate.service.ICommentService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * <p>
 * 评论表 服务实现类
 * </p>
 *
 * @author weiximei
 * @since 2019-03-20
 */
@Service
public class CommentServiceImpl extends ServiceImpl<CommentMapper, Comment> implements ICommentService {

    @Autowired
    private CommentMapper commentMapper;

    @Autowired
    private CustomerMapper customerMapper;

    @Override
    public ResponseBean addComment(SysUser user, String parameter) {
        ResponseBean responseBean = new ResponseBean();
        Comment comment = JSONObject.parseObject(parameter, Comment.class);
        comment.setCreateDate(LocalDateTime.now());
        comment.setStatus(1);

        QueryWrapper<Customer> customerQueryWrapper = new QueryWrapper<>();
        customerQueryWrapper.eq("customer_id", comment.getCustomerId());
        Customer customer = customerMapper.selectOne(customerQueryWrapper);
        if (null == customer) {
            responseBean.addError("用户不存在!");
            return responseBean;
        }

        int insert = commentMapper.insert(comment);
        if (insert <= 0) {
            responseBean.addError("评论失败!");
            return responseBean;
        }
        responseBean.addSuccess("评论成功!");
        return responseBean;
    }
}
